@replaceMethod(CraftingSystem)
public final const func GetItemFinalUpgradeCost(itemData: wref<gameItemData>) -> array<IngredientData> {
    let i: Int32;
    let ingredients: array<IngredientData>;
    let tempStat: Float;
    let statsSystem: ref<StatsSystem> = GameInstance.GetStatsSystem(this.GetGameInstance());
	//Replaced upgradeNumber with upgradeScale, defined by dividing ItemLevel with 51 (max itemLevel is around 500)
	let upgradeScale: Int32 = Cast(statsSystem.GetStatValue(itemData.GetStatsObjectID(), gamedataStatType.ItemLevel)/51.00) + 1;
    //let upgradeNumber: Float = itemData.GetStatValueByType(gamedataStatType.WasItemUpgraded);
    //upgradeNumber += 1.00;
    ingredients = this.GetItemBaseUpgradeCost(itemData.GetItemType(), RPGManager.GetItemQuality(itemData));
    i = 0;
    while i < ArraySize(ingredients) {
	  //Replaced upgradeNumber with upgradeScale
      ingredients[i].quantity = ingredients[i].quantity * upgradeScale;
	  //ingredients[i].quantity = ingredients[i].quantity * Cast(upgradeNumber);
      ingredients[i].baseQuantity = ingredients[i].quantity;
      i += 1;
    };
    tempStat = statsSystem.GetStatValue(Cast(this.m_playerCraftBook.GetOwner().GetEntityID()), gamedataStatType.UpgradingCostReduction);
    if tempStat > 0.00 {
      i = 0;
      while i < ArraySize(ingredients) {
        ingredients[i].quantity = Cast(Cast(ingredients[i].quantity) * (1.00 - tempStat));
        i += 1;
      };
    };
    return ingredients;
  }